package examen.horloge;

import java.time.LocalTime;
import static org.junit.jupiter.api.Assertions.assertEquals;
import org.junit.jupiter.api.Test;

public class HeureTest {
  @Test
  void testHeureIntIntInt() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    // résultat attendu
    int hAttendue = 12;
    // résultat effectif
    int hEffective = heure.getHeure();
    assertEquals(hAttendue, hEffective, "heure devrait être à 12");
  }
  
  @Test
  void testHeureLocalTime() {
    
    // données de test
    Heure heure = new Heure(LocalTime.now());
    // résultat attendu
    int hAttendue = LocalTime.now().getHour();
    // résultat effectif
    int hEffective = heure.getHeure();
    assertEquals(hAttendue, hEffective, "heure devrait être à 15");
  }
  
  @Test
  void testSetHeure() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    heure.setHeure(13);
    // résultat attendu
    int hAttendue = 13;
    // résultat effectif
    int hEffective = heure.getHeure();
    assertEquals(hAttendue, hEffective, "heure devrait être à 13");
  }
  
  @Test
  void testGetMinute() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    // résultat attendu
    int mAttendue = 14;
    // résultat effectif
    int mEffective = heure.getMinute();
    assertEquals(mAttendue, mEffective, "minute devrait être à 14");
  }
  
  @Test
  void testSetMinute() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    heure.setMinute(54);
    // résultat attendu
    int mAttendue = 54;
    // résultat effectif
    int mEffective = heure.getMinute();
    assertEquals(mAttendue, mEffective, "minute devrait être à 54");
  }
  
  @Test
  void testGetSeconde() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    // résultat attendu
    int sAttendue = 17;
    // résultat effectif
    int sEffective = heure.getSeconde();
    assertEquals(sAttendue, sEffective, "seconde devrait être à 17");
  }
  
  @Test
  void testSetSeconde() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    heure.setSeconde(28);
    // résultat attendu
    int sAttendue = 28;
    // résultat effectif
    int sEffective = heure.getSeconde();
    assertEquals(sAttendue, sEffective, "seconde devrait être à 28");
  }
  
  @Test
  void testHashCode() {
    // données de test
    Heure heure = new Heure(12, 14, 17);
    int hc = heure.hashCode();
    // résultat attendu
    int hcAttendu = 41774;
    // résultat effectif
    int hcEffectif = hc;
    assertEquals(hcAttendu, hcEffectif, "hashCode devrait être à 41774");
  }
}
