package examen.horloge;

import java.time.LocalTime;

/**
 * <p>Heure class.</p>
 *
 * @author db200253
 * @version $Id: $Id
 */
public class Heure {
  private int heure;
  private int minute;
  private int seconde;

  /**
   * <p>Constructor for Heure.</p>
   *
   * @param heureJava a {@link java.time.LocalTime} object
   */
  public Heure(LocalTime heureJava) {
    heure = heureJava.getHour();
    minute = heureJava.getMinute();
    seconde = heureJava.getSecond();
  }

  /**
   * <p>Constructor for Heure.</p>
   *
   * @param heure a int
   * @param minute a int
   * @param seconde a int
   */
  public Heure(int heure, int minute, int seconde) {
    super();
    this.heure = heure;
    this.minute = minute;
    this.seconde = seconde;
  }

  /**
   * <p>Getter for the field <code>heure</code>.</p>
   *
   * @return a int
   */
  public int getHeure() {
    return heure;
  }

  /**
   * <p>Setter for the field <code>heure</code>.</p>
   *
   * @param heure a int
   */
  public void setHeure(int heure) {
    this.heure = heure;
  }

  /**
   * <p>Getter for the field <code>minute</code>.</p>
   *
   * @return a int
   */
  public int getMinute() {
    return minute;
  }

  /**
   * <p>Setter for the field <code>minute</code>.</p>
   *
   * @param minute a int
   */
  public void setMinute(int minute) {
    this.minute = minute;
  }

  /**
   * <p>Getter for the field <code>seconde</code>.</p>
   *
   * @return a int
   */
  public int getSeconde() {
    return seconde;
  }

  /**
   * <p>Setter for the field <code>seconde</code>.</p>
   *
   * @param seconde a int
   */
  public void setSeconde(int seconde) {
    this.seconde = seconde;
  }

  /** {@inheritDoc} */
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + heure;
    result = prime * result + minute;
    result = prime * result + seconde;
    return result;
  }

  /** {@inheritDoc} */
  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (obj == null) {
      return false;
    }
    if (getClass() != obj.getClass()) {
      return false;
    }
    Heure other = (Heure) obj;
    if (heure != other.heure) {
      return false;
    }
    if (minute != other.minute) {
      return false;
    }
    if (seconde != other.seconde) {
      return false;
    }
    return true;
  }

}
